Ext.define('CustomApp', {
    extend: 'Rally.app.App',
    componentCls: 'app',
    launch: function () {
        //Write app code here
        console.log("Overall App Launch function entered");
        //API Docs: https://help.rallydev.com/apps/2.1/doc/
    }
});

Rally.onReady(function () {
    Ext.define('BOA.AdoptedWork.MultiArtifactGrid', {
        extend: 'Rally.app.App',
        componentCls: 'app',

        launch: function () {
            console.log("onReady Launch function entered");
            this.theGrid = {
                xtype: 'rallygrid',
                showPagingToolbar: true,
                showRowActionsColumn: false,
                editable: false,
                columnCfgs: [
                    'FormattedID',
                    'Name',
                    'ScheduleState',
                    'Iteration',
                    'Release',
                    'PlanEstimate',
                    'TaskEstimateTotal',
                    'TaskActualTotal', // For some reason this does not display ?? :o( ??
                    'TaskRemainingTotal'
                ],
                listeners: {
                    afterrender: {
                        fn: function (_myVar, eOpts) {
                            console.log("Arg to afterrender: ", _myVar, " and ", eOpts);
                            var _myStore = _myVar.getStore();
                            console.log("Store filters: ", _myStore.filters);
                        }
                    }
                },
                storeConfig: {
                    models: ['userstory', 'defect'], 
                    allowFunctions: true,                   
                    filters: [{
                        // This did not work ...
                        property: 'Iteration.Name',
                        value: 'Sprint 3',
                        // Trying dynamic Filter Function.  Update: Never called.
                        filterFn: function (item) {
                            console.log("Entered Filter Function!");
                            var iter = item.get("Iteration");
                            console.log("Iteration field: ", iter);
                            if (iter !== null && iter !== undefined) {
                                return (iter.name === "Sprint 3");
                            } else {
                                return false;
                            }
                        }
                    }]
                },
                context: this.getContext(),
                scope: this
            };
            this.add(this.theGrid);
            console.log("The Grid Object: ", this.theGrid);
        }
    });


    Rally.launchApp('BOA.AdoptedWork.MultiArtifactGrid', {
        name: 'Multi-type Grid'
    });
});